#pragma resource "divsnd.res"
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#if WINVER < 0x0400 || defined(__GNUC__)
#include "acm.h"
#else
#include <mmreg.h>
#include <msacm.h>
#endif
#include <stdio.h>
#include <math.h>
#include <sys\stat.h>
#include "divsnd.h"
#define ID_LISTVIEW 100
#define APPNAME "DIVSND"
#define chgsize(hwnd,x,y) SetWindowPos(hwnd,NULL,0,0,x,y,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE)
#define MAX(a,b) ((a)>(b)?(a):(b))
#define MIN(a,b) ((a)>(b)?(b):(a))
#ifdef WIN32
	#define MAXPATH 260
	#define MAXNAME 256
#else
	#define MAXPATH 80
	#define MAXNAME 13
#endif
WORD Version, DosVersion; BOOL NT;
HWND hwndApp, hwndList, hwndChild, hwndPlay, hwndStop, hwndOpen, hwndSave, hwndLoop;
HWND hwndDiv, hwndJoin, hwndDel;
HINSTANCE hinstApp;
BOOL Japan=1;
char buf[512];
static char achFilePath[MAXPATH], achFileTitle[MAXNAME]="noname.txt";
HMMIO hmmio;
DWORD dwTotalDataSize, dwDataSize, BytesPerSec;
MMCKINFO mmckinfoParent, mmckinfoSubchunk;
HLOCAL hFormat;
PCMWAVEFORMAT *pFormat;
int khz, bits, wavetype, step, dispmode=IDM_WAVE, x, xx, yy, cxChar;
WORD formattag;
BOOL vbr;
static short int blockalign=1;
HWAVEOUT hWaveOut;
int buffnum=4, stopflag=0, UsingBuffer, last, steptime, deltatime=8192;
#define BUFNUM 4
static HGLOBAL hData[BUFNUM] = {NULL};
static HPSTR  lpData[BUFNUM] = {NULL};
static HGLOBAL hWaveHdr[BUFNUM];
static LPWAVEHDR lpWaveHdr[BUFNUM] = {NULL};
DWORD WaveDataSize[BUFNUM], WaveBufSize, DispBufSize, StartTick, PauseTick;
BOOL status, loop=1;
int HTATE,HYOKO,startpos, curpos, endpos, setpos, bunkai, nokori;
int waveOutSetPosition(HWAVEOUT hwo, LPWAVEHDR pwh, LPMMTIME pmmt);
MMTIME mmt;

#define MsgBox(str) MessageBox(hwndApp, (str), NULL, MB_OK)
#define ErrMsg(str) MessageBox(hwndApp, (str), NULL, MB_OK | MB_ICONEXCLAMATION)
#define logwrite(msg) ((void)(msg))
#define logwrite2(fmt, msg) ((void)(fmt), (void)(msg))
#if defined(__TURBOC__) || defined(__LCC__)
#define FASTCALL static near PASCAL
#define NEARFAST        near PASCAL
#else
#define FASTCALL static near __fastcall
#define NEARFAST        near __fastcall
#endif
#define MONO_8BIT    0
#define MONO_16BIT   1
#define STEREO_8BIT  2
#define STEREO_16BIT 3
#define HEXBIT       1
#define STEREO       2
#if 1
#define Assert(p)	((p)?(void)0:(\
	sprintf(buf,"Assertion failed: %s, file %s, line %d",#p, __FILE__, __LINE__),\
	MessageBox(NULL, buf, NULL, MB_OK),abort() ))
#else
#define Assert(p)	((void)0)
#endif
void SetPriority(BOOL pri){}
HMENU hmenu;
void playbuttonenable(BOOL flag){
	int mf=(flag?MF_ENABLED:MF_GRAYED);
	char fname[256], fname2[256], *p;
	EnableWindow(hwndPlay, flag);
	EnableMenuItem(hmenu,IDM_PLAY, mf);
	if (Version<0x500){
		EnableWindow(hwndLoop, flag);
		EnableMenuItem(hmenu,IDM_LOOP, mf);
	}
	ListView_GetItemText(hwndList, 0, 0, fname, sizeof(fname));
	strcpy(fname2, achFileTitle);
	p=strrchr(fname2, '.'); if (p) *p=0;
	if (strcmp(fname, fname2)==0)
		 EnableMenuItem(hmenu,IDM_SAVE, MF_GRAYED),
		 EnableWindow(hwndSave, FALSE);
	else EnableMenuItem(hmenu,IDM_SAVE, mf),
		 EnableWindow(hwndSave, flag);
	EnableMenuItem(hmenu,IDM_OPEN, mf),
	EnableWindow(hwndOpen, flag);
	//sprintf(buf, "%d %d", strlen(fname), strlen(fname2));
	//MessageBox(hwndApp, buf, fname2, MB_OK);
}
void stopbuttonenable(BOOL flag){
	int mf=(flag?MF_ENABLED:MF_GRAYED);
	EnableWindow(hwndStop, flag);
	EnableMenuItem(hmenu,IDM_STOP, mf);
}
long dispmeter(HDC hdc, int PlayedBuffer, long ReadSize){return 0;}


#ifdef __LCC__
#define _fmemset(p,c,s) memset((p),(c),(s))
#endif
#define hmemset(p,c,s) memset((p),(c),(s))
#define hmemcopy(p,c,s) memcpy((p),(c),(s))
void FASTCALL fillbuf(int i, long size) {
#if MEMDBG   /*fobOp*/
	if (bits==16) hmemset(lpData[i], 0x80, size);
	else          hmemset(lpData[i], 0x00, size);
#else
	if (bits==16) hmemset(lpData[i], 0x00, size);
	else          hmemset(lpData[i], 0x80, size);
#endif
}
char *ldstr(int id){return NULL;}
void FASTCALL calcstep(long calctime, HDC hdc){
	unsigned t; static long prevcalc; long delta, now;
	delta=calctime-prevcalc; now=timeGetTime();
	if (khz%11) t=deltatime/8.0   +0.5;
	else        t=deltatime/11.025+0.5;
	Assert(t);
	sprintf(buf, " %.2f %.2f ", (double)delta/t, (double)(now-calctime)/t);
	///*if (delta/t) TextOut(hdc, 170, 0, buf, 5);
	//else*/ TextOut(hdc, 210, 0, buf, strlen(buf));
	if (buffnum==1) t=MAX(t*1.2, 55);
	if      (delta>t*1.09) {step*=2;if (step==0) step=65535U;}//1.05
	else if (delta>t*1.01) {step++; if (step==0) step=65535U;}
	else{
		delta=now-calctime;
		//Assert(t);
		//sprintf(buf, " d=%ld  t=%u  %.2f s=%u ", delta, t, (double)delta/t, step);
		//TextOut(hdc, 80, 80, buf, strlen(buf));
		if      (delta<t*(0.35-0.20) && step>=4) step/=2;
		else if (delta<t*(0.50-0.20) && step>60) step/=2;
		else if (delta<t*(0.89-0.08) && step>=9) step--;//0.81
		else if (delta<t*(0.86-0.10) && step>=7) step--;//0.76
		else if (delta<t*(0.80-0.12) && step>=5) step--;
		else if (delta<t*(0.75-0.14) && step>=4) step--;
		else if (delta<t*(0.67-0.18) && step>=3) step--;
		else if (delta<t*(0.50-0.20) && step>=2) step--;//0.30
	}
	prevcalc=calctime;
}
void FASTCALL free_hdata(void){
	int i, m;
	if (buffnum==1) m=2; else m=buffnum;
	for (i=0; i<m; i++) {
		*lpData[i]=0;
		if (GlobalUnlock(hData[i]))MessageBox(hwndApp, "GlobalUnlock", NULL, MB_OK);
		lpData[i]=NULL;
		if (GlobalFree(hData[i]))  MessageBox(hwndApp, "GlobalFree", NULL, MB_OK);
		hData[i]=NULL;
	}
}
void FASTCALL atosimatu(void){
	stopbuttonenable(FALSE);/* STOP{^𖳌*/
	free_hdata();
	status=FALSE;
	/*PLAY{^ĂїL */
	playbuttonenable(TRUE);
}
int zenkaidisp, zenkaistep, zenkaistart, count;
BOOL notDisp=0;
void FASTCALL InitBar(void){
	zenkaidisp=HYOKO+1;
	zenkaistep=0;
	zenkaistart=-1;
	count=0;
}

void FASTCALL DispBar(int yobidasi, int StReq, int EndReq){
	int sa;
	EndReq=0;
	if (notDisp) {--notDisp; return;}
	if (nokori/bunkai!=zenkaidisp){
		int step, step2; 
		HDC hdc=GetDC(hwndChild);
		if (zenkaidisp==0) zenkaidisp=HYOKO+1;

		if (buffnum==2 && EndReq) step=(int)(WaveBufSize/blockalign/bunkai);
		//if (buffnum==BUFNUM && EndReq) step=(int)(WaveBufSize/blockalign/bunkai);
		else if (khz%11==0) step=khz/11*deltatime/bunkai;
		else                step=khz/8.0*deltatime/bunkai;
		if (status==0) step=1;
		if (step==0) step=1;
		step2=step*2; if (StReq || EndReq) step2=step;
		if (zenkaistep==0) zenkaistep=step;
		if (StReq)
			PatBlt(hdc, (int)(HYOKO-zenkaidisp-step), 0, step2, HTATE, DSTINVERT);
		sa=zenkaidisp-nokori/bunkai;if (status==0) sa=0;
		PatBlt(hdc, (int)(HYOKO-nokori/bunkai-sa), 0, sa+step, HTATE, DSTINVERT);
		ReleaseDC(hwndChild, hdc);
#if 0
		{	
			HDC hdc=GetDC(hwndApp);
			//sprintf(buf, "%d  %d  %d  ", (HYOKO-nokori/bunkai-step), 
			//	(HYOKO-nokori/bunkai-step)-(HYOKO-zenkaidisp-step), step2);
			sprintf(buf, "%d z=%d n/b=%d s=%d s2=%d sa=%d x=%d dx=%d ", yobidasi, zenkaidisp, nokori/bunkai, step, step2, sa, (HYOKO-nokori/bunkai-sa), sa+step);

			TextOut(hdc, 530, yy+count*20, buf, strlen(buf));
			count++;
			ReleaseDC(hwndApp, hdc);
		}
#endif
		zenkaidisp=nokori/bunkai; zenkaistep=step;
	}else{
#if 0
		HDC hdc=GetDC(hwndApp);
		//sprintf(buf, "%d  %d  %d  ", (HYOKO-nokori/bunkai-step), 
		//	(HYOKO-nokori/bunkai-step)-(HYOKO-zenkaidisp-step), step2);
		sprintf(buf, "%d z=%d n/b=%d ", yobidasi, zenkaidisp, nokori/bunkai);

		TextOut(hdc, 530, /*y+*/count*20, buf, strlen(buf));
		count++;
		ReleaseDC(hwndApp, hdc);
#endif
	}
	if (nokori<=0)nokori=(endpos-startpos)/blockalign;
	else nokori-=(WaveBufSize/blockalign);
	if (nokori<=0) nokori=0;
	//if (nokori<=0) WaveDataSize[PlayedBuffer] = 0;
	//sprintf(buf,"%10d   ",nokori);
	//TextOut(hdc, 0, 0, buf, strlen(buf));
}
void FASTCALL OnWaveOutDone(LPWAVEHDR lpwh) {
	static int count=-1;
	int PlayedBuffer;
	int EndReq;
	long starttime, ReadSize;
	HDC hdc;
	HFONT hfont, hfontOld; LOGFONT lf;
	//long readtime, preptime, endtime, unptime;
	//static long prevtime; static int isem, icount;
	count++;
	if (stopflag) return;
	hdc=GetDC(hwndApp);
	//isem++;  icount++;
	//if (isem!=1) TextOut(hdc, 240, 90, "ƭ", 5);
#if 0
	if      (deltatime>=8192)               wait(khz%11?400:320); // 0.7b
	else if (deltatime==4096 && pitch<  20) wait(khz%11?400:320); // 1/3b
	else if (deltatime==4096 && pitch<  80) wait(khz%11?300:210);
	else if (deltatime==4096)               wait(khz%11?200:140);
	else if (deltatime==2048 && pitch<-100) wait(khz%11?400:320); // 1/5b~2
	else if (deltatime==2048 && pitch< -40) wait(khz%11?300:210);
	else if (deltatime==2048 && pitch<  20) wait(khz%11?200:140); // 1/5b
	else if (deltatime==2048 && pitch<  80) wait(khz%11?150:105);
	else if (deltatime==2048)               wait(khz%11?100:50);
	else if (deltatime==1024 && pitch<-220) wait(khz%11?400:320); // 1/11b~4
	else if (deltatime==1024 && pitch<-160) wait(khz%11?300:210);
	else if (deltatime==1024 && pitch<-100) wait(khz%11?200:140); // 1/11b~2
	else if (deltatime==1024 && pitch< -40) wait(khz%11?150:105);
	else if (deltatime==1024 && pitch<  20) wait(khz%11?100:50);  // 1/11b
	else if (deltatime== 512 && pitch<-220) wait(khz%11?200:140);
	else if (deltatime== 512 && pitch<-160) wait(khz%11?150:105);
	else if (deltatime== 512 && pitch<-100) wait(khz%11?100:50);
#elif 0
	{
		unsigned t, lim;                                        //0.78
		if (Version >= 0x35f) lim=113; else lim=50;
		if (khz%11) t=deltatime/8     *pow(0.5, pitch/120.0)*0.88+0.5;//200
		else        t=deltatime/11.025*pow(0.5, pitch/120.0)*0.88+0.5;//145
		if (t>400) t=400;
		//sprintf(buf, "W=%3d ", t); TextOut(hdc, 0, 40, buf, strlen(buf));
		if (t<=lim)
			t=t*0.66/*, sprintf(buf, "%3d ", t), TextOut(hdc, 48, 40, buf, strlen(buf))*/;
		if (t>33 && formattag != 85 /*&& wait_on*/) wait(t, hdc);
	}
#endif
	starttime=timeGetTime();
	//if (hanten) SetTextColor(hdc, RGB(255,255,255)), SetBkColor(hdc, RGB(0,0,0));
	//FONTSET();
	{
		//unsigned t;  static long PrevWaitEnd; long WaitEnd=timeGetTime();
		//if (khz%11) t=deltatime/8     *pow(0.5, pitch/120.0)+0.5;//200
		//else        t=deltatime/11.025*pow(0.5, pitch/120.0)+0.5;//145
		//sprintf(buf, "%4ld  ", starttime-prevtime); prevtime=starttime;
		//TextOut(hdc, (icount%4)*60, 70, buf, strlen(buf));
		//sprintf(buf, "%4ld  ", WaitEnd-PrevWaitEnd); PrevWaitEnd=WaitEnd;
		//TextOut(hdc, (icount%4)*60, 0, buf, strlen(buf));
		//sprintf(buf, "T=%4u  ", t);
		//TextOut(hdc, 240, 0, buf, strlen(buf));
	}
	// obt@ԍXV
	EndReq=HIWORD(lpwh->dwUser);
	PlayedBuffer=LOWORD(lpwh->dwUser);   //PlayedBuffer=UsingBuffer;
	UsingBuffer = (UsingBuffer+1)%BUFNUM;//UsingBuffer = !UsingBuffer;
	//sprintf(buf, "%d %c ", count, EndReq?'E':'N');
	//TextOut(hdc, 0, PlayedBuffer*16, buf, strlen(buf));
	//playedsize+=WaveDataSize[PlayedBuffer];
	// ǂݏooCg
	if (loop) last=FALSE;
	if (dwDataSize <= WaveBufSize) ReadSize = dwDataSize, last=TRUE;
	else                           ReadSize = WaveBufSize;
	WaveDataSize[PlayedBuffer]=ReadSize;
	//sprintf(buf, "%d %d ", PlayedBuffer,lpwh->dwBufferLength);
	//TextOut(hdc, 0, count*20, buf, strlen(buf));
	// wb_
	//unptime=timeGetTime();
	if (hWaveOut) {
		//debugout2("wOUH %d\n", PlayedBuffer);
		waveOutUnprepareHeader(hWaveOut, lpWaveHdr[PlayedBuffer], sizeof(WAVEHDR));
		lpWaveHdr[PlayedBuffer]->lpData=NULL;
	}else{
		//FONTDEL();
		ReleaseDC(hwndApp, hdc);
		return;
	}
	//unptime=timeGetTime()-unptime;
	/* TCY\ */
	//if (buffnum==1) {
	//	int ix=yoko*9, iy=tate*7;
	//	Assert(BytesPerSec);
	//	sprintf(buf,"Pos:  %7ld KB %6.0f sec", (WaveBufSize+blockalign)/1024,
	//		(double)WaveBufSize/BytesPerSec);
	//	TextOut(hdc, ix, iy, buf, strlen(buf));
	//}else PrintTime(hdc);
	dwDataSize-=ReadSize;
	DispBar(PlayedBuffer, 0, EndReq);
	if (EndReq && loop) DispBar(-1, 0, EndReq), EndReq=0;
	if (EndReq == 0){
		//sprintf(buf, "%d  ", WaveDataSize[UsingBuffer]);
		//TextOut(hdc, 0, 0, buf, strlen(buf));
		//dispmeter(hdc, UsingBuffer, WaveDataSize[UsingBuffer]);
	}
	if (EndReq == 0 && ReadSize > 0) {
		// obt@փ[h
		//sprintf(buf, "RS=%ld  b=%d", ReadSize, blockalign);
		//TextOut(hdc, 60, 40, buf, strlen(buf));
		//readtime=timeGetTime();
		mmioRead(hmmio, lpData[PlayedBuffer], ReadSize);
		//preptime=timeGetTime();
		//readtime=preptime-readtime;
		// wb_Zbg
		lpWaveHdr[PlayedBuffer]->lpData=(LPSTR)lpData[PlayedBuffer];
		lpWaveHdr[PlayedBuffer]->dwBufferLength=WaveDataSize[PlayedBuffer];
		lpWaveHdr[PlayedBuffer]->dwFlags=0;
		if (last) lpWaveHdr[PlayedBuffer]->dwUser |= 0x10000000UL;
		else      lpWaveHdr[PlayedBuffer]->dwUser = PlayedBuffer;
		if (loop) last=0;
		// wb_o^
		//debugout2("Pre %d\n", PlayedBuffer);
		waveOutPrepareHeader(hWaveOut, lpWaveHdr[PlayedBuffer], sizeof(WAVEHDR));
		// obt@Xg֒ǉ
		waveOutWrite(hWaveOut, lpWaveHdr[PlayedBuffer], sizeof(WAVEHDR));
		//endtime=timeGetTime();
		//preptime=endtime-preptime;
		//sprintf(buf, "R=%3ld P=%3ld U=%3ld T=%4ld T-RPU=%3ld ", readtime, preptime, unptime,
		//	endtime-starttime, endtime-starttime-readtime-preptime-unptime);
		//TextOut(hdc, 0, 20, buf, strlen(buf));
		if (dwDataSize==0 && loop) {
			//sprintf(buf, "%d ", startpos); TextOut(hdc, 0, 0, buf, strlen(buf));
			dwDataSize=endpos-startpos;
			mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
		}
		calcstep(starttime, hdc);
	}else{
		//WaveDataSize[PlayedBuffer]=0;
		if (EndReq) {
		//end:
			/* ̃bZ[W̓EF[utH[f[^ubN̍ĐIA
			 * ł邱ƂBȑOɏwb_[ */
			if (buffnum == 1) KillTimer(hwndApp, 1);
			else{
				int i;
				//waveOutReset(hWaveOut); debugout("waveOutReset\n");
				for(i=0; i<buffnum ; ++i) {
					//debugout2("wOUP %d\n", i);
					if (lpWaveHdr[i]->lpData)
						waveOutUnprepareHeader(hWaveOut,lpWaveHdr[i],sizeof(WAVEHDR));
				}
			}
			/* EF[utH[o̓foCXN[Y */
			SetPriority(0); waveOutClose(hWaveOut); hWaveOut = NULL;
			//TextOut(hdc, 0, 0, "close", 5);
			atosimatu();
			//if (levelwarning) levelMessage(hwndApp, "onwaveoutdone");
		}//else EndReq=TRUE;
	}
	//FONTDEL();
	ReleaseDC(hwndApp, hdc);
	//isem--;
}

DWORD GetformMem(HLOCAL *hFormat, PCMWAVEFORMAT **pFormat, DWORD dwFmtSize){
	if (*hFormat!=NULL)
		LocalUnlock(*hFormat), *pFormat=NULL, LocalFree(*hFormat), *hFormat=NULL;
	*hFormat = LocalAlloc(LMEM_MOVEABLE, LOWORD(dwFmtSize));
	if (!*hFormat) {
		ErrMsg(Japan?"ɓx̃słB":ldstr(IDS_NOMEM));
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
	*pFormat = (PCMWAVEFORMAT *) LocalLock(*hFormat);
	if (!*pFormat) {
		ErrMsg(Japan?"̃bNɎs܂B":ldstr(IDS_MEMLK));
		LocalFree( *hFormat ); *hFormat=NULL;
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
	return dwFmtSize;
}
#define MaxMemSize 400
void FASTCALL CalcBufSize(PCMWAVEFORMAT *pFormat){
	if (pFormat->wf.nAvgBytesPerSec % 11025 == 0)
		DispBufSize = pFormat->wf.nAvgBytesPerSec / 11025 * deltatime;
	//else if (pFormat->wf.nSamplesPerSec % 12000 == 0)
		//DispBufSize = pFormat->wf.nAvgBytesPerSec / 12000.0 * deltatime + 0.5;
	else if (pFormat->wf.nSamplesPerSec == 12000)
		DispBufSize = pFormat->wf.nAvgBytesPerSec / 8000.0 * deltatime + 0.5;
	else if (pFormat->wf.nAvgBytesPerSec % 8000 == 0)
		DispBufSize = pFormat->wf.nAvgBytesPerSec / 8000 * deltatime;
	else if (pFormat->wf.nSamplesPerSec  % 11025 == 0)
		DispBufSize = (long)(pFormat->wf.nAvgBytesPerSec / 11025.0 * deltatime + 0.5);
	else
		DispBufSize = (long)(pFormat->wf.nAvgBytesPerSec / 8000.0 * deltatime + 0.5);
	if (buffnum == BUFNUM) {
		if (pFormat->wf.wFormatTag == 85) {
			blockalign=((WORD *)pFormat)[12]; //blocksize
			if (GetKeyState(VK_SHIFT)<0) blockalign++;
			if (GetKeyState(VK_CONTROL)<0) blockalign=512;
			//blockalign=((WORD *)pFormat)[13]; //frames
		}
		WaveBufSize = DispBufSize;
		Assert(blockalign!=0);
		if (WaveBufSize % blockalign) {
			WaveBufSize -= (WaveBufSize % blockalign);
			if (WaveBufSize%2) WaveBufSize+=blockalign;
			if (pFormat->wf.wFormatTag == 85 && (WaveBufSize/blockalign)%2)
				WaveBufSize+=blockalign;
		}
	}else{
		if (dwTotalDataSize < MaxMemSize*1048576UL) WaveBufSize = dwTotalDataSize;
		else WaveBufSize = MaxMemSize*1048576L;
	}
	if (Version<=0x030b && buffnum==1 && WaveBufSize%65536L==0)
			WaveBufSize -= pFormat->wf.nBlockAlign;
	//if (pFormat->wf.nAvgBytesPerSec % 11025 == 0)
	//	nokori=bunkai*HYOKO-(pFormat->wf.nAvgBytesPerSec/11025*deltatime)/blockalign;
	//else
	//	nokori=bunkai*HYOKO-(pFormat->wf.nAvgBytesPerSec/8000.0*deltatime)/blockalign;
	nokori=((endpos-curpos)/blockalign);
}
int FASTCALL GetWaveMemory(void){
	int i, m; HCURSOR hcur;
	if (buffnum==1) m=2, hcur=LoadCursor(NULL, IDC_WAIT), hcur=SetCursor(hcur);
	else m=buffnum;
	for (i=0; i<m; ++i){
		long size;
		if (buffnum==1 && i==1) size=DispBufSize;
		else size=WaveBufSize;
		hData[i] = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, size);
		if (!hData[i]) {
			if (buffnum==1) SetCursor(hcur);
			for (--i; i>=0; --i)
				GlobalUnlock(hData[i]), lpData[i]=NULL, GlobalFree(hData[i]), hData[i]=NULL;
			ErrMsg(Japan?"słB":ldstr(IDS_NEMEM));
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			return 0;
		}
		lpData[i] = (HPSTR)GlobalLock(hData[i]);
		if (!lpData[i]) {
			if (buffnum==1) SetCursor(hcur);
			sprintf(buf, Japan?"f[^ `ÑbNɎs܂B%d %ld":ldstr(IDS_DLOCK),
				i, WaveBufSize);
			ErrMsg(buf);
			GlobalFree(hData[i]); hData[i]=NULL;
			for (--i; i>=0; --i)
				GlobalUnlock(hData[i]), lpData[i]=NULL, GlobalFree(hData[i]), hData[i]=NULL;
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			return 0;
		}
		fillbuf(i, size);
		//{
		//	HDC hdc=GetDC(hwndApp);
		//	sprintf(buf, "h=%p lp=%p sz=%lu ", hData[i], lpData[i], size);
		//	TextOut(hdc, 0, i*16, buf, strlen(buf));
		//	ReleaseDC(hwndApp, hdc);
		//}
	}
	if (buffnum==1) SetCursor(hcur);
	return 1;
}
void FASTCALL readfail(int no, long ReadSize){
	sprintf(buf, Japan?"f[^`Nǂݎ܂B%d %ld":ldstr(IDS_NRDDT), no, ReadSize);
	ErrMsg(buf);
	free_hdata();
	if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
	waveOutClose(hWaveOut); hWaveOut=NULL;
	playbuttonenable(TRUE);
}
void FASTCALL headerfail(void){
	ErrMsg(Japan?"EF[uwb_[̏ł܂":ldstr(IDS_HDFAL));
	//if (buffnum==1) leveltext(NULL);
	free_hdata();
	waveOutClose(hWaveOut), hWaveOut=NULL;
	playbuttonenable(TRUE);
}

PMPEGLAYER3WAVEFORMAT mp3fmt;

void SetTitleBar(HWND hwnd, char *name){
	char buf[14+MAXNAME];
	if (name==NULL) sprintf(buf, APPNAME":()");
	else            sprintf(buf, APPNAME":%s", name);
	SetWindowText(hwnd, buf);
}
#define msgout(str) ((void)str)
int filerecover(void){
	struct stat statbuf;
	stat(achFilePath, &statbuf);
	if ((ULONG)statbuf.st_size>44UL) {
		FILE *fp=fopen(achFilePath, "r+b");
		if (fp){
			ULONG data, fmtsize, fact=0, writepos; short fmttype; char four[5];
			fseek(fp, 0, SEEK_SET); fread(four, 1, 4, fp); four[4]=0;
			if (strcmp(four, "RIFF")) {msgout("NOT RIFF"); return 1;}
			fseek(fp, 12, SEEK_SET); fread(four, 1, 4, fp); four[4]=0;
			if (strcmp(four, "fmt ")) {msgout("NOT exist fmt"); return 1;}
			fseek(fp, 16, SEEK_SET); fread(&fmtsize, 4, 1, fp);
			fseek(fp, 20, SEEK_SET); fread(&fmttype, 2, 1, fp);
			fseek(fp, 32, SEEK_SET); fread(&blockalign, 2, 1, fp);
			if (blockalign==0) blockalign=1;
			fseek(fp, 20+fmtsize, SEEK_SET); fread(four, 1, 4, fp); four[4]=0;
			if (strcmp(four, "fact")==0) {
				fseek(fp, 24+fmtsize, SEEK_SET); fread(&fact, 4, 1, fp);
			}else if(strcmp(four, "data")){msgout("NOT exist data"); return 1;}
			if (fact) data=(ULONG)statbuf.st_size-8-28-fmtsize-fact;
			else      data=(ULONG)statbuf.st_size-8-20-fmtsize;
	    // 2:MS-ADPCM 115:SBC16 26447`26449:ogg
			if (fmttype!=2 && fmttype!=115 && (fmttype<26447||26449<fmttype)) {
				if (data%blockalign) data-=(data%blockalign);
			}
			if (fact) writepos=24+fmtsize+fact+8;
			else      writepos=24+fmtsize;
			if ((ULONG)statbuf.st_size<writepos+4){msgout("under");return 1;}
			fseek(fp, writepos, SEEK_SET); fwrite(&data, 4, 1, fp);
			if (fact) data=data+fmtsize+28+fact;
			else      data=data+fmtsize+20;
			if (data%2!=0 && (ULONG)statbuf.st_size>data+8) data+=1;//Ȃ+1
			fseek(fp, 4, SEEK_SET); fwrite(&data, 4, 1, fp);
			fclose(fp); return 0;
		}else msgout("cant open");
	}else msgout("under44");
	return 1;
}
void FASTCALL SetWaveType(PCMWAVEFORMAT *pFormat){
	HDC hdc=GetDC(hwndApp);
	HFONT hfont, hfontOld; LOGFONT lf;
	//if (hanten) SetTextColor(hdc, RGB(255,255,255)), SetBkColor(hdc, RGB(0,0,0));
	//FONTSET();
	//BitBlt(hdc, X_LEVEL, Y_LEVEL-tate, yoko*35, tate*5, NULL, 0, 0, BLACKNESS);
	if (pFormat->wf.nChannels == 2) wavetype = STEREO; else wavetype = 0;
	if (pFormat->wf.nChannels == 1 && pFormat->wBitsPerSample ==  8) wavetype = MONO_8BIT;
	if (pFormat->wf.nChannels == 1 && pFormat->wBitsPerSample == 16) wavetype = MONO_16BIT;
	if (pFormat->wf.nChannels == 2 && pFormat->wBitsPerSample ==  8) wavetype = STEREO_8BIT;
	if (pFormat->wf.nChannels == 2 && pFormat->wBitsPerSample == 16) wavetype = STEREO_16BIT;
	blockalign = pFormat->wf.nBlockAlign;
	BytesPerSec = pFormat->wf.nAvgBytesPerSec;
	khz=(int)((pFormat->wf.nSamplesPerSec+500)/1000);
	formattag = pFormat->wf.wFormatTag;
	if (formattag==26447 || formattag==26448 || formattag==26449) bits=0;
	else bits=pFormat->wBitsPerSample;
	//PrintWaveType(hdc);
	//PrintTime(hdc);
	//FONTDEL();
	ReleaseDC(hwndApp, hdc);
}
int PrePlay(void) {
	DWORD dwFmtSize; MMRESULT r;
	BOOL riff=1;

	if (achFilePath[0]==0) {
		ErrMsg(Japan?"t@ĆB":ldstr(IDS_NONAM));
		return 0;
	}
	if (hmmio) {
		mmioAscend(hmmio, &mmckinfoSubchunk, 0);
		mmioAscend(hmmio, &mmckinfoParent, 0);
		mmioClose(hmmio, 0); hmmio=NULL;
	}
retry2:
	/* obt@tI/OgēǂݎpƂăt@CJ */
	if((hmmio = mmioOpen(achFilePath, NULL, MMIO_READ | MMIO_ALLOCBUF))==NULL){
		ErrMsg(Japan?"t@CJ܂B":ldstr(IDS_NOPEN));
		return 0;
	}
	dwTotalDataSize=0; BytesPerSec=0;
	/* 'WAVE'tH[^Cv'RIFF'`NAꂪWAVEt@Cł邩ǂmF */
	//mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
	mmckinfoParent.fccType = mmioFOURCC('\0', '\0', '\0', '\0');
	if (mmioDescend(hmmio, (LPMMCKINFO) &mmckinfoParent, NULL, MMIO_FINDRIFF)) {
		int i;
		riff=0;
		ErrMsg(Japan?"w肵t@ĆARIFFt@Cł͂܂B":ldstr(IDS_NOWAV));
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
	if (mmckinfoParent.cksize == 0){
		int ans=MessageBox(hwndApp, Japan?"WAVEt@CĂ܂B\nC݂܂H":ldstr(IDS_RECOV), NULL, MB_YESNO);
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		if (ans==IDYES){
			if (filerecover()==0) goto retry2;
			else ErrMsg(Japan?"Cs":"cant recover");
		}
		return 0;
	}
	if (mmckinfoParent.fccType != mmioFOURCC('W', 'A', 'V', 'E')){
		int i;
		mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
		if (mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK)) {
			ErrMsg(Japan?"RIFFt@CɃf[^ `N܂B":ldstr(IDS_NODAT));
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			return 0;
		}
		dwTotalDataSize = dwDataSize = mmckinfoSubchunk.cksize;
		ErrMsg(Japan?"w肵t@ĆAWAVEt@Cł͂܂B":ldstr(IDS_NOWAV));
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}

	/* ``N(tH[^Cv'fmt')B
	 * ́Ae`N'RIFF'̃Tu`NłȂ΂ȂȂ */
	mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
	if (mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK)) {
		ErrMsg(Japan?"WAVEt@CĂ܂B":ldstr(IDS_DESTR));
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}

	if ((dwFmtSize=GetformMem(&hFormat, &pFormat, mmckinfoSubchunk.cksize))==0) return 0;
	//sprintf(buf, "%ld", dwFmtSize); ErrMsg(buf);

	/* ``Nǂݎ */
	if (mmioRead(hmmio, (HPSTR)pFormat, dwFmtSize) != (LRESULT) dwFmtSize) {
		ErrMsg(Japan?"``Nǂݎ܂B":ldstr(IDS_NRFMT));
		LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
	mmioAscend(hmmio, &mmckinfoSubchunk, 0);/* `Tu`Nړ */
#if 1
	formattag=pFormat->wf.wFormatTag;
	/* PCMt@Cł邱ƂmF */
	if (pFormat->wf.wFormatTag != WAVE_FORMAT_PCM) {
		ErrMsg(Japan?"w肵t@ĆAPCMt@Cł͂܂B":"not PCM");
		LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
#endif
mp3restart:
	SetWaveType(pFormat);
	/* EF[utH[o̓foCX̌`T|[gĂ邩ǂmF
	 * ۂɂ̓foCXI[vȂ */
#if 0
	sprintf(buf, "tag=%hd c=%hd f=%ld a=%ld b=%hd", pFormat->wf.wFormatTag,
													pFormat->wf.nChannels,
													pFormat->wf.nSamplesPerSec,
													pFormat->wf.nAvgBytesPerSec,
													pFormat->wf.nBlockAlign);
	//ErrMsg(buf);
#endif
	if (pFormat->wf.wFormatTag==85) {
		//mp3fmt=(PMPEGLAYER3WAVEFORMAT)pFormat; mp3fmtprint();
		//if (pFormat->wf.nSamplesPerSec==48000UL) pFormat->wf.nSamplesPerSec=44100UL;
		//mp3fmt->wfx.nAvgBytesPerSec/=2;
	}
retry:
	//Windows3.1ACMŃXeIɂ炸I[vɎs邱Ƃ
	//if (Version>0x30b || pFormat->wf.wFormatTag==1 || pFormat->wf.nChannels==1)
		if ((r=waveOutOpen(&hWaveOut, (UINT)WAVE_MAPPER, (LPWAVEFORMATEX)pFormat, (DWORD)NULL, 0L,
				(DWORD)WAVE_FORMAT_QUERY))!=0) {
			//disptotaltime();
			if (r==MMSYSERR_BADDEVICEID)
				ErrMsg(Japan?"͈͊ÕfoCXIDw肳܂B":ldstr(IDS_NOPOV));
			else if(r==MMSYSERR_ALLOCATED)
				ErrMsg(Japan?"̃\tgĐHgĂ܂B":ldstr(IDS_NOPOV));
			else if(r==MMSYSERR_NOMEM)
				ErrMsg(Japan?"̊蓖Ăł܂B"      :ldstr(IDS_NOMEM));
			else if (r==WAVERR_BADFORMAT) {
				if (pFormat->wf.nSamplesPerSec==48000UL) {
					pFormat->wf.nSamplesPerSec=44100UL; goto retry;
				}
				if (Version<=0x30b && pFormat->wf.wFormatTag!=1 && pFormat->wf.nChannels!=1){
					pFormat->wf.nChannels=1; goto retry;
				}
				ErrMsg(Japan?"̌`ĐłhCo܂B":ldstr(IDS_NOSUP));
			}else ErrMsg(Japan?"o̓foCXJ܂B"      :ldstr(IDS_NOPOV));
			LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			return 0;
		}
	if (pFormat->wf.nSamplesPerSec==44100UL && khz==48) pFormat->wf.nSamplesPerSec=48000UL;
	if (riff) {
		/* f[^Tu`N */
		mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
		if (mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK)) {
			ErrMsg(Japan?"WAVEt@CɃf[^ `N܂B":ldstr(IDS_NODAT));
			LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			return 0;
		}
		//if(oggheadread(NULL,54)) ErrMsg("ogg");
		/* f[^Tu`ÑTCY擾 */
		dwTotalDataSize = dwDataSize = mmckinfoSubchunk.cksize;
	}else{
		dwTotalDataSize = dwDataSize = mmioSeek(hmmio, 0, SEEK_END);
		mmioSeek(hmmio, 0, SEEK_SET);
	}
	//܂œǂݍ݃I[v
	//diskfree(achFilePath);

	if (dwDataSize == 0L) {
		ErrMsg(Japan?"f[^ `NłB":ldstr(IDS_EMPTY));
		LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return 0;
	}
	//disptotaltime();
	return 1;
}
void FASTCALL StopButton(void){
	int i;
	if (buffnum == 1) KillTimer(hwndApp, 1);
	stopbuttonenable(FALSE);
	stopflag = 1;
	waveOutReset(hWaveOut); //debugout("waveOutReset\n");
	for(i=0; i<buffnum ; ++i) {
		//debugout2("wOUP %d\n", i);
		if (lpWaveHdr[i]->lpData)
			waveOutUnprepareHeader(hWaveOut,lpWaveHdr[i],sizeof(WAVEHDR));
	}
	SetPriority(0); waveOutClose(hWaveOut); hWaveOut=NULL;
	//if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
	playbuttonenable(TRUE);
	free_hdata();
	status=FALSE;
}
void PlayButton(void) {
	MMRESULT r; int i; HDC hdc;
	unsigned long ReadSize;
	HCURSOR hcur;
	HFONT hfont, hfontOld; LOGFONT lf;
	long readtime, preptime, disptime, writetime, calctime;
	//if (GetKeyState(VK_SHIFT)<0) wait_on=1; else wait_on=0;

	//peaklevel=0; levelover=0;
	if (hmmio==NULL || pFormat==NULL)
		if (PrePlay()==0) return;

	//if (0){
	//	char ststr[100], edstr[100];
	//	int index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
	//	if(index == -1) index=0;
	//	ListView_GetItemText(hwndList, index, 1, ststr, sizeof(ststr));
	//	ListView_GetItemText(hwndList, index, 2, edstr, sizeof(edstr));
	//	endpos  =(long)(strtod(edstr,NULL)*BytesPerSec)/blockalign*blockalign;
	//	startpos=(long)(strtod(ststr,NULL)*BytesPerSec)/blockalign*blockalign;
	//}

	dwDataSize=endpos-startpos;
	/*if (disksize <= 1457664L)*/ buffnum = 1; 
	/*else*/ buffnum = BUFNUM;
	//playedsize=0;
	CalcBufSize(pFormat);

	if (formattag==85) {
		mp3fmt=(PMPEGLAYER3WAVEFORMAT)pFormat; //mp3fmtprint();
		if (vbr) mp3fmt->wfx.nAvgBytesPerSec/=2;
	}
	if (hWaveOut) {
		//MessageBox(NULL,"CLOSEY",NULL,MB_OK);
		waveOutClose(hWaveOut),hWaveOut=NULL;
	}
	/* EF[utH[o̓foCXI[v */
retry:
	//hdc=GetDC(hwndApp);
	//TextOut(hdc, 0, 0, "open ", 5);
	//ReleaseDC(hwndApp, hdc);
	
	if ((r=waveOutOpen((LPHWAVEOUT)&hWaveOut, (UINT)WAVE_MAPPER, (LPWAVEFORMATEX)pFormat,
	(DWORD)(UINT)hwndApp, (DWORD)0L, (DWORD)CALLBACK_WINDOW))!=0) {
		if (r==MMSYSERR_BADDEVICEID)
			ErrMsg(Japan?"͈͊ÕfoCXIDw肳܂B":ldstr(IDS_NOPOV));
		else if(r==MMSYSERR_ALLOCATED)
			ErrMsg(Japan?"̃\tgTEhgĂ܂B":ldstr(IDS_NOPOV));
		else if(r==MMSYSERR_NOMEM)
			ErrMsg(Japan?"̊蓖Ăł܂B"      :ldstr(IDS_NOMEM));
		else if (r==WAVERR_BADFORMAT) {
			if (pFormat->wf.nSamplesPerSec==48000UL){
				pFormat->wf.nSamplesPerSec=44100UL; goto retry;
			}
			ErrMsg(Japan?"̌`ĐłhCo܂B":ldstr(IDS_NOSUP));
		}else ErrMsg(Japan?"o̓foCXJ܂B"      :ldstr(IDS_NOPOV));
		LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
		if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
		return;
	}
	logwrite("waveoutopen");
	/* wb_[̏ÎŁA */
	LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
	logwrite("unlock");

	/* EF[utH[f[^̂߂̃蓖āAbN */
	//if (buffnum==1) leveltext(Japan?"t@Cǂݍݒ":ldstr(IDS_RDFIL));
	playbuttonenable(FALSE);
	if (GetWaveMemory()==FALSE){
		waveOutClose(hWaveOut);	hWaveOut=NULL;
		playbuttonenable(TRUE);
		return;
	}
	logwrite("getwavemem");

	/*ĐJn*/
	InitBar(); status=TRUE; DispBar(-1, 0, 0);
	UsingBuffer=0; last=FALSE;
	//if (formattag != WAVE_FORMAT_PCM && Version >= 0x35f) mixer_junbi();
	/* EF[utH[f[^Tu`Nǂݎ */
	if (buffnum==1) hcur=LoadCursor(NULL, IDC_WAIT), hcur=SetCursor(hcur);
	readtime=timeGetTime();
	for (i=0; i<buffnum; ++i) {
		WaveDataSize[i]=0;
		lpWaveHdr[i]->lpData = NULL;
	}
	if (buffnum==1) mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset, SEEK_SET);
	else mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+curpos, SEEK_SET);
	for (i=0; i<buffnum; ++i) {
		if (dwDataSize <= WaveBufSize) ReadSize=dwDataSize, last=TRUE;
		else                           ReadSize=WaveBufSize;
		dwDataSize -= ReadSize;
		WaveDataSize[i]=ReadSize;
		if(mmioRead(hmmio, (HPSTR)lpData[i], ReadSize) != (LRESULT) ReadSize) {
			status=FALSE; SetPriority(0);
			if (buffnum==1) SetCursor(hcur);
			readfail(i, ReadSize);
			return;
		}
		//if (ReadSize) UsingBuffnum++;
		if (i==0) readtime=timeGetTime()-readtime;
		if (dwDataSize==0 && loop) {
			dwDataSize=endpos-startpos;
			//nokori=(dwDataSize/blockalign);
			mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
		}
	}
	if (buffnum==1) WaveDataSize[1]=0, SetCursor(hcur);
	logwrite("usingbuffnum");
	preptime=timeGetTime();
//#define waveOutPrepareHeader(hWaveOut, lp, size) (1)
//#define waveOutWrite(hWaveOut, lp, size)         (1)
	// NɂOԂƂPԃobt@̗o^Ă܂
	/* WAVEHDR\̂̃oɒlݒ肵AEF[ufoCXɃf[^ޏ */
	SetPriority(1);
	for (i=0; i<buffnum && WaveDataSize[i]>0; ++i) {
		_fmemset(lpWaveHdr[i], 0, sizeof(WAVEHDR));
		if (buffnum==1 && curpos!=0){
			lpWaveHdr[i]->lpData = &((LPSTR)lpData[i])[curpos];
			lpWaveHdr[i]->dwBufferLength = WaveDataSize[i]-curpos;
		}else{
			lpWaveHdr[i]->lpData = (LPSTR)lpData[i];
			lpWaveHdr[i]->dwBufferLength = WaveDataSize[i];
		}
		lpWaveHdr[i]->dwFlags = 0L;
		lpWaveHdr[i]->dwLoops = 0L;
		lpWaveHdr[i]->dwUser  = i;
		if (loop==0){
			if (i<BUFNUM-1&&WaveDataSize[i+1]==0) lpWaveHdr[i]->dwUser|=0x10000000UL;
			if (i==BUFNUM-1&&dwDataSize      ==0) lpWaveHdr[i]->dwUser|=0x10000000UL;
		}else{
			if (WaveDataSize[i]<WaveBufSize) lpWaveHdr[i]->dwUser|=0x10000000UL;
		}
		logwrite2("Pre %d", i);
		if(waveOutPrepareHeader(hWaveOut, lpWaveHdr[i], sizeof(WAVEHDR))) {
			headerfail(); if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			status=FALSE; return;
		}
		logwrite2("Pre success %d", i);
		disptime=timeGetTime();
		preptime=disptime-preptime;
		if (buffnum==1) {
			if (khz%11) steptime=deltatime/8;
			else steptime=(int)(deltatime*1000L/11025);
			//StartTick=timeGetTime(); PauseTick=StartTick;
			//hdc=GetDC(hwndApp);
			//BitBlt(hdc, X_LEVEL, Y_LEVEL-tate, yoko*35, tate*5, NULL, 0, 0, BLACKNESS);
			//if (hanten) SetTextColor(hdc, RGB(255,255,255)), SetBkColor(hdc, RGB(0,0,0));
			//FONTSET();
			//offsetbak=0; step=1; timedone(hdc, StartTick);
			//FONTDEL();
			//dispchar(hdc);
			//ReleaseDC(hwndApp, hdc);
			//SetTimer(hwndApp, 1, steptime, NULL);
		} else if (i==0) {
			hdc=GetDC(hwndApp);
			step=1; calctime=dispmeter(hdc, 0, WaveDataSize[0])-disptime;
			ReleaseDC(hwndApp, hdc);
		}
		writetime=timeGetTime();
		disptime=writetime-disptime-calctime;
		/* łf[^ubNo̓foCXɑiĐn܂j */
		logwrite2("write %d", i);
		if (waveOutWrite(hWaveOut, lpWaveHdr[i], sizeof(WAVEHDR)) != 0) {
			logwrite2("write failed %d", i);
			ErrMsg(Japan?"foCXւ̏o͂Ɏs܂B":ldstr(IDS_FLWRT));
			waveOutUnprepareHeader(hWaveOut, lpWaveHdr[i], sizeof(WAVEHDR));
			free_hdata();
			SetPriority(0); waveOutClose(hWaveOut); hWaveOut=NULL;
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			playbuttonenable(TRUE);
			status=FALSE; return;
		}
		logwrite2("write success %d", i);
		writetime=timeGetTime()-writetime;
		if (buffnum==1) {
			SetTimer(hwndApp, 1, steptime, NULL);
			StartTick=PauseTick=timeGetTime();/* ᑬCPU΍ */
		} else if (i==0){
			long ttt;
			if (khz%11) ttt=deltatime/8     *0.99+0.5;//200
			else        ttt=deltatime/11.025*0.99+0.5;//145
			ttt-=(readtime+preptime+disptime+writetime)*1.15;
			if (ttt<=0) step=65535U;
			else step=calctime*2.9/ttt+0.95;
			if (step==0) step=1;
			//if (GetKeyState(VK_SHIFT)<0) step=1; else step=100;
			//hdc=GetDC(hwndApp);
			//sprintf(buf,"t=%ld r=%ld p=%ld d=%ld w=%ld ",
			//	ttt+readtime+preptime+disptime+writetime,
			//	readtime, preptime, disptime, writetime);
			//TextOut(hdc,0,40,buf,strlen(buf));
			//sprintf(buf, "nkr=%ld c=%ld s=%u ", ttt, calctime, step);
			//TextOut(hdc,0,80,buf,strlen(buf));
			//ReleaseDC(hwndApp, hdc);
		}
	}

	/* STOPyPAUSE{^L */
	stopbuttonenable(TRUE);
	stopflag = 0;
	logwrite("success\n");
}
void readtext (HWND hwnd, char *path, char *name){
	LV_ITEM item; char fname[256]; char *p;
	SetTitleBar(hwnd, name);
	ListView_DeleteAllItems(hwndList);
	InvalidateRect(hwndChild, NULL, TRUE);
	if (PrePlay()==0) return;
	startpos=0; curpos=0; endpos=dwTotalDataSize;
	item.mask = LVIF_TEXT;
	strcpy(fname, name);
	p=strrchr(fname, '.');
	if (p) *p=0;
	//擪J
	item.pszText=fname;
	item.iItem=0;	item.iSubItem=0;
	ListView_InsertItem(hwndList, &item);
	//Ԗ
	item.pszText="0.00000";
	item.iSubItem=1;
	ListView_SetItem(hwndList, &item);
	//OԖځ`lԖ
	sprintf(buf, "%.5f", (double)dwTotalDataSize/BytesPerSec);
	item.pszText=buf;
	item.iSubItem=2;
	ListView_SetItem(hwndList, &item);
	item.iSubItem=3;
	ListView_SetItem(hwndList, &item);
	playbuttonenable(TRUE);
	EnableMenuItem(hmenu,IDM_SAVE, MF_GRAYED);
	EnableWindow(hwndSave, FALSE);
	EnableMenuItem(hmenu,IDM_RENM, MF_GRAYED);
	EnableMenuItem(hmenu,IDM_DIV, MF_ENABLED);EnableWindow(hwndDiv,TRUE);
	ListView_SetItemState(hwndList, 0, LVIS_SELECTED|LVIS_FOCUSED,
									   LVIS_SELECTED|LVIS_FOCUSED);
	EnableMenuItem(hmenu,IDM_DEL, MF_GRAYED),
	EnableWindow(hwndDel,FALSE);
}
void divsnd(double divpos){
	char fname[256], fname2[256], ststr[100], edstr[100]; double st, ed;
	int index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
	LV_ITEM item;
	if(index == -1) index=0;
	//wsprintf(szMsg, "%dsDblClick!", (index + 1));
	ListView_GetItemText(hwndList, index, 0, fname, sizeof(fname));
	ListView_GetItemText(hwndList, index, 1, ststr, sizeof(ststr));
	ListView_GetItemText(hwndList, index, 2, edstr, sizeof(edstr));
	st=strtod(ststr, NULL);
	ed=strtod(edstr, NULL);
	item.mask = LVIF_TEXT;
	strcpy(fname2, fname); strcat(fname2, "-1");
	item.pszText=fname2;
	item.iItem=index;	item.iSubItem=0;
	ListView_InsertItem(hwndList, &item);
	item.pszText=ststr;item.iSubItem=1;
	ListView_SetItem(hwndList, &item);
	sprintf(buf, "%.5f", st+(ed-st)*divpos);
	item.pszText=buf; item.iSubItem=2;
	ListView_SetItem(hwndList, &item);
	sprintf(buf, "%.5f", (ed-st)*divpos);
	item.pszText=buf; item.iSubItem=3;
	ListView_SetItem(hwndList, &item);

	strcpy(fname2, fname); strcat(fname2, "-2");
	item.pszText=fname2;
	item.iItem=index+1; item.iSubItem=0;
	ListView_InsertItem(hwndList, &item);
	sprintf(buf, "%.5f", st+(ed-st)*divpos);
	item.pszText=buf;item.iSubItem=1;
	ListView_SetItem(hwndList, &item);
	item.pszText=edstr; item.iSubItem=2;
	ListView_SetItem(hwndList, &item);
	sprintf(buf, "%.5f", (ed-st)*(1-divpos));
	item.pszText=buf; item.iSubItem=3;
	ListView_SetItem(hwndList, &item);
	ListView_DeleteItem(hwndList, index+2);
	//curpos=st+(ed-st)*divpos*BytesPerSec;
	//curpos-=(curpos%blockalign);

	ListView_SetItemState(hwndList, index+1, LVIS_SELECTED|LVIS_FOCUSED,
											 LVIS_SELECTED|LVIS_FOCUSED);
	SetFocus(hwndList);
	if (status==0){
		EnableMenuItem(hmenu,IDM_SAVE, MF_ENABLED);
		EnableWindow(hwndSave, TRUE);
	}
	EnableMenuItem(hmenu,IDM_RENM, MF_ENABLED);
	EnableMenuItem(hmenu,IDM_DEL, MF_ENABLED),
	EnableWindow(hwndDel,TRUE);
}
void catsnd(void){
	int index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED),n;
	double st, ed; char ststr[100], edstr[100];
	if (index<=0) return;
	ListView_GetItemText(hwndList, index-1, 0, buf, sizeof(buf));
	if (strcmp(buf, "NUL")==0){
		for(n=2;;++n){
			if (index<n) return;
			ListView_GetItemText(hwndList, index-n, 0, buf, sizeof(buf));
			if (strcmp(buf, "NUL")!=0) break;
		}
		ListView_SetItemText(hwndList, index, 0, buf);
		return;
	}

	ListView_GetItemText(hwndList, index-1, 1, ststr, sizeof(ststr));
	ListView_GetItemText(hwndList, index,   2, edstr, sizeof(edstr));
	st=strtod(ststr, NULL);
	ed=strtod(edstr, NULL);

	ListView_SetItemText(hwndList, index-1, 2, edstr);
	sprintf(buf, "%.5f", ed-st);
	ListView_SetItemText(hwndList, index-1, 3, buf);
	ListView_DeleteItem(hwndList, index);

	ListView_SetItemState(hwndList, index-1, LVIS_SELECTED|LVIS_FOCUSED,
											 LVIS_SELECTED|LVIS_FOCUSED);
	SetFocus(hwndList);
}


/****************************************************************************
t@C
 ****************************************************************************/
#define CHECKMESSAGE \
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {\
		if (msg.message==WM_QUIT) exit(1);\
		TranslateMessage(&msg);\
		DispatchMessage(&msg);\
	}
#define CHECKMESSAGE2 \
	while (PeekMessage(&msg,NULL,0,0, PM_REMOVE)) {\
		if (msg.message==WM_QUIT) exit(1);\
		TranslateMessage(&msg);\
		DispatchMessage(&msg);\
	}
void FASTCALL filesave(char *newfile, double st, double ed, int mode) {
	static MMCKINFO DstWaveFile;
	static MMCKINFO DstWaveData;
	static HMMIO hmmioW;
	MSG msg;
	long ReadSize;
	MMCKINFO DstWaveFmt;
	WAVEFORMATEX DstHeader;
	//int chudan;
	int startpos, endpos;


	if (hmmio==NULL || hFormat==NULL)
		if (PrePlay()==0) return;

	//playedsize=0;
	CalcBufSize(pFormat);
	if (formattag!=WAVE_FORMAT_PCM) {
		//ErrMsg(Japan?"PCMłȂߏs\":"Can't process, Not PCM");
		//return;
	}

	if (mode==MMIO_CREATE)
		hmmioW=mmioOpen(newfile, NULL, MMIO_CREATE|MMIO_WRITE);
	else
		hmmioW=mmioOpen(newfile, NULL, MMIO_READWRITE);

	if (hmmioW==NULL){
		ErrMsg(Japan?"݃t@CJ܂B":ldstr(IDS_NOPEN));
		return;
	}

	if (mode==MMIO_CREATE){
		DstWaveFile.fccType=mmioStringToFOURCC("WAVE",MMIO_TOUPPER);
		if (mmioCreateChunk(hmmioW, &DstWaveFile, MMIO_CREATERIFF)) {
			ErrMsg(Japan?"RIFF`N쐬ł܂":ldstr(IDS_NCRIF));
			mmioClose(hmmioW, 0); hmmioW=NULL;
			return;
		}

		DstWaveFmt.ckid=mmioStringToFOURCC("fmt ",0);
		DstWaveFmt.cksize=sizeof(PCMWAVEFORMAT);
		if (mmioCreateChunk(hmmioW,&DstWaveFmt,0)){
			ErrMsg(Japan?"FMT`N쐬ł܂":ldstr(IDS_NCFMT));
			mmioClose(hmmioW, 0); hmmioW=NULL;
			return;
		}
		if (formattag == WAVE_FORMAT_PCM){
			memcpy(&DstHeader, pFormat, sizeof(PCMWAVEFORMAT));
			mmioWrite(hmmioW,(char far*)&DstHeader,sizeof(PCMWAVEFORMAT));
		}else{
			memcpy(&DstHeader, pFormat, sizeof(WAVEFORMATEX));
			mmioWrite(hmmioW,(char far*)&DstHeader,sizeof(WAVEFORMATEX));
		}
		mmioAscend(hmmioW,&DstWaveFmt,0);

		DstWaveData.ckid=mmioStringToFOURCC("data",0);
		DstWaveData.cksize=0;
		if (mmioCreateChunk(hmmioW,&DstWaveData,0)){
			ErrMsg(Japan?"f[^`N쐬ł܂":ldstr(IDS_NCDAT));
			LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			mmioClose(hmmioW, 0); hmmioW=NULL;
			return;
		}
	}else{
		//f[^`NɓĖɃV[N
		/* 'WAVE'tH[^Cv'RIFF'`NA
		ꂪWAVEt@Cł邩ǂmF */
		mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
		if (mmioDescend(hmmioW, (LPMMCKINFO) &mmckinfoParent, NULL, MMIO_FINDRIFF)) {
			MessageBox(hwndApp, "w肵t@ĆAWAVEt@Cł͂܂B",
				   NULL, MB_OK | MB_ICONEXCLAMATION);
			//mmioClose(hmmio, 0); hmmio=NULL;
			return;
		}
	#if 0
		/* ``N(tH[^Cv'fmt')B
		 * ́Ae`N'RIFF'̃Tu`NłȂ΂ȂȂ */
		mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
		if (mmioDescend(hmmiwW, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK)) {
			MessageBox(hwndApp, "WAVEt@CĂ܂B", 
			NULL, MB_OK | MB_ICONEXCLAMATION);
			//mmioClose(hmmio, 0); hmmio=NULL;
			return 0;
		}
		//if ((dwFmtSize=GetformMem(&hFormat, &pFormat))==0) return 0;

		/* ``Nǂݎ */
		if (mmioRead(hmmioW, (HPSTR) pFormat, dwFmtSize) != (LRESULT) dwFmtSize) {
			MessageBox(hwndApp, "``Nǂݎ܂B", 
			NULL, MB_OK | MB_ICONEXCLAMATION);
			//LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			//mmioClose(hmmio, 0); hmmio=NULL;
			return 0;
		}
		//SetWaveType(pFormat);
		//wf.nSamplesPerSec  = pFormat->wf.nSamplesPerSec;
		//wf.nAvgBytesPerSec = pFormat->wf.nAvgBytesPerSec;
		/* PCMt@Cł邱ƂmF */
		if (pFormat->wf.wFormatTag != WAVE_FORMAT_PCM) {
			MessageBox(hwndApp, "w肵t@ĆAPCMt@Cł͂܂B",
				NULL, MB_OK | MB_ICONEXCLAMATION);
			//LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			//mmioClose(hmmio, 0); hmmio=NULL;
			return 0;
		}
		mmioAscend(hmmioW, &mmckinfoSubchunk, 0);/* `Tu`Nړ */
	#endif
		/* f[^Tu`N */
		mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
		if (mmioDescend(hmmioW, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK)) {
			MessageBox(hwndApp, "WAVEt@CɃf[^ `N܂B",
				   NULL, MB_OK | MB_ICONEXCLAMATION);
			LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;
			//mmioClose(hmmio, 0); hmmio=NULL;
			return;
		}
		//܂œǂݍ݃I[v
		/* f[^Tu`ÑTCY擾 */
		//dwTotalDataSize = dwDataSize = mmckinfoSubchunk.cksize;
		//blockalign=pFormat->wf.nBlockAlign;
		//if (position>=dwTotalDataSize-pFormat->wf.nBlockAlign) position=0;
		//if (dwDataSize == 0L) {
		//}else{
		//	dwDataSize=dwTotalDataSize-position;
		//}
		//diskfree(achFilePath);
		mmioSeek(hmmioW, mmckinfoSubchunk.dwDataOffset+
		                 mmckinfoSubchunk.cksize, SEEK_SET);
		//mmioSeek(hmmioW, 0, SEEK_END);
	}
	/* wb_[̏ÎŁA */
	LocalUnlock(hFormat); pFormat=NULL; LocalFree(hFormat); hFormat=NULL;

	//debugout("temp0");

	/* EF[utH[f[^̂߂̃蓖āAbN */
	if (GetWaveMemory()==FALSE){
		return;
	}
	//debugout("temp1");

	//debugout("temp2");
	UsingBuffer=0; last=FALSE;
	/* EF[utH[f[^Tu`Nǂݎ */
	WaveDataSize[0]=0;

	endpos  =(long)(ed*BytesPerSec)/blockalign*blockalign;
	startpos=(long)(st*BytesPerSec)/blockalign*blockalign;
	dwDataSize=endpos-startpos;

	mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
	//int mf=(flag?MF_ENABLED:MF_GRAYED);
	//chudan=0;
	for(;;){
		//CHECKMESSAGE2
		//if (chudan) break;
		// ǂݏooCg
		if (dwDataSize <= WaveBufSize) ReadSize = dwDataSize, last=TRUE;
		else                           ReadSize = WaveBufSize;
		/* TCY\ */
		//playedsize+=ReadSize;
		//status=1; PrintTime(hdc); status=0;
		dwDataSize-=ReadSize;
		//dispmeter(hdc, UsingBuffer, WaveDataSize[UsingBuffer]);
		if (ReadSize == 0) break;
		// obt@փ[h
		mmioRead(hmmio, lpData[0], ReadSize);
		if (mmioWrite(hmmioW, lpData[0], ReadSize)!=ReadSize)
			{ErrMsg("Disk full or Disk I/O error"); break;}
	}
	mmioAscend(hmmioW,&DstWaveData,0);
	mmioAscend(hmmioW,&DstWaveFile,0);
	mmioClose(hmmioW, 0); hmmioW=NULL;
}
void writetext(void){
	int i, imax, index; char fname[256], fnamebak[256], *ext;
	char ststr[100], edstr[100]; double st, ed, last;
	HDC hdc=GetDC(hwndChild);
	//EnableWindow(hwndApp, FALSE);
	EnableMenuItem(hmenu,IDM_SAVE, MF_GRAYED),EnableWindow(hwndSave, FALSE);
	EnableMenuItem(hmenu,IDM_OPEN, MF_GRAYED),EnableWindow(hwndOpen, FALSE);
	EnableMenuItem(hmenu,IDM_PLAY, MF_GRAYED),EnableWindow(hwndPlay, FALSE);
	EnableMenuItem(hmenu,IDM_DIV,  MF_GRAYED),EnableWindow(hwndDiv,  FALSE);
	EnableMenuItem(hmenu,IDM_JOIN, MF_GRAYED),EnableWindow(hwndJoin, FALSE);
	PatBlt(hdc, 0, 0, HYOKO, HTATE, WHITENESS);
	imax=ListView_GetItemCount(hwndList);
	ListView_GetItemText(hwndList, imax-1, 2, edstr, sizeof(edstr));
	last=strtod(edstr, NULL);
	ext=strrchr(achFileTitle, '.');
	if (ext==NULL) ext=".WAV";
	fnamebak[0]=0;
	for(i=0; i<imax; ++i){
		ListView_GetItemText(hwndList, i, 0, fname, sizeof(fname));
		ListView_GetItemText(hwndList, i, 1, ststr, sizeof(ststr));
		ListView_GetItemText(hwndList, i, 2, edstr, sizeof(edstr));
		st=strtod(ststr, NULL);
		ed=strtod(edstr, NULL);
		strcat(fname, ext);
		if (strcmp(fname, fnamebak)!=0) filesave(fname, st, ed, MMIO_CREATE);
		else                            filesave(fname, st, ed, !MMIO_CREATE);
		if (strncmp(fname, "NUL.", 4)!=0) strcpy(fnamebak, fname);
		PatBlt(hdc, 0, 0, HYOKO*ed/last, HTATE, BLACKNESS);
		Sleep(100);
	}
	ReleaseDC(hwndChild, hdc);
	Sleep(100);
	InvalidateRect(hwndChild, NULL, TRUE);
	EnableMenuItem(hmenu,IDM_SAVE, MF_ENABLED),EnableWindow(hwndSave, TRUE);
	EnableMenuItem(hmenu,IDM_OPEN, MF_ENABLED),EnableWindow(hwndOpen, TRUE);
	EnableMenuItem(hmenu,IDM_PLAY, MF_ENABLED),EnableWindow(hwndPlay, TRUE);
	EnableMenuItem(hmenu,IDM_DIV,  MF_ENABLED),EnableWindow(hwndDiv,  TRUE);
	index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
	if (index) EnableMenuItem(hmenu,IDM_JOIN, MF_ENABLED),
			   EnableWindow(hwndJoin,TRUE);
	else       EnableMenuItem(hmenu,IDM_JOIN, MF_GRAYED),
			   EnableWindow(hwndJoin,FALSE);
	//EnableWindow(hwndApp, TRUE);
}
void RenameWave(void){
	int i, imax=ListView_GetItemCount(hwndList), n;
	char fname[256], bak[256]=""; char *p;
	strcpy(fname, achFileTitle);
	p=strrchr(fname, '.');
	if (p) *p=0;
	for(i=0, n=1; i<imax; ++i){
		ListView_GetItemText(hwndList, i, 0, buf, sizeof(buf));
		if (strcmp(buf, "NUL")!=0) {
			if (strcmp(bak, buf)!=0) strcpy(bak, buf);
			else --n;
			sprintf(buf, "%s-%d", fname, n); ++n;
			ListView_SetItemText(hwndList, i, 0, buf);
		}
	}
}
void fileclose(void){
	if (hmmio){
		SetPriority(0);
		mmioClose(hmmio, 0); hmmio=NULL;
		if (hWaveOut) waveOutClose(hWaveOut), hWaveOut=NULL;
	}
}

long CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam){
	int i;
	static OPENFILENAME ofn; static char filenamebackup[260];
	switch (message) {
	case WM_SETFOCUS: SetFocus(hwndList); return 0;
	case WM_NOTIFY:
		if ((int)wparam == ID_LISTVIEW) {
			LPNMHDR lpnmhdr = (LPNMHDR)lparam;
			if( lpnmhdr->hwndFrom == GetDlgItem(hwnd, ID_LISTVIEW) ){
				char ststr[100], edstr[100]; int index; static int oldindex=-1;
				//switch( lpnmhdr->code ){
				//case NM_CLICK: case NM_RETURN: case NM_KEYDOWN:
					//MessageBox(hwnd, "DBLCLK RETURN", "NOTIFY", MB_OK);
					if(status && (lpnmhdr->code==-102||lpnmhdr->code==-100)) break;
					index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
					if(index == -1) break;
					if(index==oldindex) break;
					if (index) EnableMenuItem(hmenu,IDM_JOIN, MF_ENABLED),
							   EnableWindow(hwndJoin,TRUE);
					else       EnableMenuItem(hmenu,IDM_JOIN, MF_GRAYED),
							   EnableWindow(hwndJoin,FALSE);
					ListView_GetItemText(hwndList, index, 0, buf, sizeof(buf));
					ListView_GetItemText(hwndList, index, 1, ststr, sizeof(ststr));
					ListView_GetItemText(hwndList, index, 2, edstr, sizeof(edstr));
					endpos=(long)(strtod(edstr,NULL)*BytesPerSec)/blockalign*blockalign;
					curpos=(long)(strtod(ststr,NULL)*BytesPerSec)/blockalign*blockalign;
					//if (endpos==0) MessageBox(NULL,"endpos",NULL,MB_OK), exit(1), abort();
					startpos=curpos;
					dwDataSize=endpos-startpos;
					InvalidateRect(hwndChild, NULL, TRUE);InitBar();
					if (status){
						//HDC hdc=GetDC(hwndApp);
						//sprintf(buf, "%d  %d  %d", index, oldindex, lpnmhdr->code);
						//TextOut(hdc, x, y, buf, strlen(buf));
						InvalidateRect(hwndList, NULL, TRUE);
						UpdateWindow(hwndList);
						UpdateWindow(hwndChild);
						nokori=(dwDataSize/blockalign);
						if (buffnum==BUFNUM){
							//MessageBox(NULL, "H", NULL, MB_OK);
							mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
							notDisp=BUFNUM-1;
							waveOutReset(hWaveOut);
						}else {
							MessageBox(NULL, "肦Ȃ͂", NULL, MB_OK);
							mmt.wType=TIME_BYTES;
							mmt.u.cb=startpos;
							waveOutSetPosition(hWaveOut, lpWaveHdr[0], &mmt);
						}
						//ReleaseDC(hwndApp, hdc);
					}
					oldindex=index;
					//MessageBox(hwnd, filename, extension, MB_OK);
					break;
				//}
			}
		}
		break;
	case WM_COMMAND:
		switch((WORD)wparam) {/*Rg[ID*/
		case IDM_OPEN:
			strcpy(filenamebackup, achFilePath);
			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hwnd;
			ofn.lpstrFilter = "(*.WAV)\0*.WAV\0St@C(*.*)\0*.*\0";
			ofn.lpstrCustomFilter = NULL;
			ofn.nFilterIndex = 1;
			achFilePath[0] = 0;
			ofn.lpstrFile = (LPSTR)achFilePath;
			ofn.nMaxFile = sizeof(achFilePath);
			ofn.lpstrFileTitle = (LPSTR)achFileTitle;
			ofn.nMaxFileTitle = sizeof(achFileTitle);
			ofn.lpstrInitialDir = NULL;
			ofn.lpstrTitle = NULL;	//ofn.lpstrTitle = "t@CJ";
			ofn.lpstrDefExt = NULL;
			ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
			if(GetOpenFileName((LPOPENFILENAME)&ofn))
				readtext(hwnd, achFilePath, achFileTitle);
			else strcpy(achFilePath, filenamebackup);
			SetFocus(hwndList);
			return 0;
		case IDM_SAVE:
			writetext();
			SetFocus(hwndList);
			return 0;
		case IDM_EXIT:
			SendMessage(hwnd, WM_CLOSE, 0, 0L);
			return 0;
		case IDM_PLAY:
			PlayButton();
			SetFocus(hwndList);
			return 0;
		case IDM_STOP:
			StopButton();
			SetFocus(hwndList);
			return 0;
		case IDM_RENM:
			RenameWave();
			SetFocus(hwndList);
			return 0;
		case IDM_DIV:
			if (buffnum==1 && status) {
				mmt.wType=TIME_BYTES;
				waveOutGetPosition(hWaveOut, &mmt, sizeof(mmt));
				dwDataSize=endpos-setpos-mmt.u.cb;
			}
			{
				BOOL statusbak=status;
				if (status && Version<0x500) StopButton();
				divsnd((double)(endpos-startpos-dwDataSize)/(endpos-startpos));
				SetFocus(hwndList);
				if (statusbak && Version<0x500) PlayButton();
			}
			return 0;
		case IDM_JOIN:
			{
				BOOL statusbak=status;
				if (status && Version<0x500) StopButton();
				catsnd();
				SetFocus(hwndList);
				if (statusbak && Version<0x500) PlayButton();
			}
			return 0;
		case IDM_LOOP:
			if (loop) CheckMenuItem(hmenu, IDM_LOOP, MF_UNCHECKED), loop=0;
			else      CheckMenuItem(hmenu, IDM_LOOP, MF_CHECKED),   loop=1;
			CheckDlgButton(hwndApp, IDM_LOOP, loop);
			SetFocus(hwndList);
			return 0;
		case IDM_DEL:{
			int index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
			if (index>=0) ListView_SetItemText(hwndList, index, 0, "NUL");
			SetFocus(hwndList);
			}return 0;
		case IDM_ABOUT:
			MessageBox(hwnd, "DIVSND 0.01", "o[W", MB_OK);
			SetFocus(hwndList);
			return 0;
		case IDM_HELP:
			if (Version>=0x0400) {
				char *p;
				GetModuleFileName(hinstApp,buf,260);
				p=strstr(buf,".EXE");
				if (p) strcpy(p,".HLP");
				else strcpy(buf,APPNAME".HLP");
				WinHelp(hwnd, buf, HELP_CONTENTS, 0L);
			}else WinHelp(hwnd, APPNAME".hlp", HELP_CONTENTS, 0L);
			SetFocus(hwndList);
			return 0;
		case IDM_LEVEL: case IDM_WAVE:
			dispmode=(WORD)wparam;
			if (dispmode==IDM_WAVE) CheckMenuItem(hmenu, IDM_WAVE, MF_CHECKED),
									CheckMenuItem(hmenu, IDM_LEVEL, MF_UNCHECKED);
			else                    CheckMenuItem(hmenu, IDM_LEVEL, MF_CHECKED),
									CheckMenuItem(hmenu, IDM_WAVE, MF_UNCHECKED);
			InvalidateRect(hwndChild, NULL, TRUE);
			return 0;
		}
		break;
	case WM_CREATE:
		{
			TEXTMETRIC tm; RECT rc,rcW;
			HDC hdc = GetDC (hwnd);
			HFONT hfont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
			HFONT hfontOld=(HFONT)SelectObject(hdc,hfont);
			GetTextMetrics (hdc, &tm);
			cxChar = tm.tmAveCharWidth;
			//sprintf(buf, "%d", cxChar); MessageBox(NULL, buf, NULL, MB_OK);
			//cxCaps = (tm.tmPitchAndFamily & 1 ? 3 : 2) * cxChar / 2;
			//cyChar = tm.tmHeight + tm.tmExternalLeading;
			SelectObject(hdc,hfontOld);
			ReleaseDC (hwnd, hdc);
			GetClientRect(hwnd, &rc);
			GetWindowRect(hwnd, &rcW);
			xx=rc.right;
			if (rc.bottom<320){
				rcW.bottom=320+(rcW.bottom-rc.bottom),
				chgsize(hwnd, rcW.right, rcW.bottom);
			}
			//sprintf(buf,"%d~%d", rcW.right, rcW.bottom);SetWindowText(hwnd, buf);
		}
		hmenu=GetMenu(hwnd);
		for(i=0; i<BUFNUM; ++i){
			hWaveHdr[i] = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, (DWORD) sizeof(WAVEHDR));
			if (hWaveHdr[i]==0) {
				ErrMsg(Japan?"wb_[mێs":ldstr(IDS_HDALF));
				return DefWindowProc(hwnd,message,wparam,lparam);
			}
			lpWaveHdr[i] = (LPWAVEHDR) GlobalLock(hWaveHdr[i]);
			if (lpWaveHdr[i]==0) {
				ErrMsg(Japan?"wb_[bNs":ldstr(IDS_HDLKF));
				GlobalFree(hWaveHdr[i]);
				for (i=i-1; i>=0; --i)
					GlobalUnlock(hWaveHdr[i]), GlobalFree(hWaveHdr[i]);
				return DefWindowProc(hwnd,message,wparam,lparam);
			}
		}
		//DragAcceptFiles(hwnd, TRUE);
		break;
	case WM_CHAR:
		if (wparam=='E' || wparam=='e') SendMessage(hwnd, WM_CLOSE, 0, 0L);
		break;
	case WM_SIZE:
		xx=LOWORD(lparam);
		//sprintf(buf,"%d~%d", xx, HIWORD(lparam));SetWindowText(hwnd, buf);
		if (hwndList)
			MoveWindow(hwndList, 0, 0, xx*0.9-2, HIWORD(lparam)*0.8, TRUE);
		if (hwndOpen)
			MoveWindow(hwndOpen,xx*0.9, 0, xx*0.1, 40, TRUE);
		if (hwndSave)
			MoveWindow(hwndSave,xx*0.9,  40, xx*0.1, 40, TRUE);
		if (hwndLoop)
			MoveWindow(hwndLoop,xx*0.9+5,80, xx*0.1, 30, TRUE);
		if (hwndPlay)
			MoveWindow(hwndPlay,xx*0.9, 110, xx*0.1, 40, TRUE);
		if (hwndStop)
			MoveWindow(hwndStop,xx*0.9, 150, xx*0.1, 40, TRUE);
		if (hwndDiv)
			MoveWindow(hwndDiv, xx*0.9, 200, xx*0.1, 40, TRUE);
		if (hwndJoin)
			MoveWindow(hwndJoin,xx*0.9, 240, xx*0.1, 40, TRUE);
		if (hwndDel)
			MoveWindow(hwndDel, xx*0.9, 280, xx*0.1, 40, TRUE);
		x=xx*0.9; yy=280;
		HTATE=HIWORD(lparam)*0.2-20; HYOKO=xx-20;
		if (HYOKO>1024) HYOKO=1024; else if (HYOKO>512) HYOKO=512; else HYOKO=256; 
		if (hwndChild)
			MoveWindow(hwndChild, 10, HIWORD(lparam)*0.8+10, HYOKO, HTATE, TRUE);
		break;
	case MM_WOM_DONE:
		OnWaveOutDone((LPWAVEHDR)lparam);
		return 0;
	case WM_QUERYENDSESSION:
	case WM_DESTROY:
		//DragAcceptFiles(hWnd, FALSE);
		if (hWaveOut && status) {
			SetPriority(0);
			if (buffnum == 1) KillTimer(hwndApp, 1);
			stopflag = 1;
			waveOutReset(hWaveOut);
			for(i=0; i<buffnum; ++i) //&& EndReq==FALSE
				if (lpWaveHdr[i]->lpData)
					waveOutUnprepareHeader(hWaveOut, lpWaveHdr[i], sizeof(WAVEHDR));
			waveOutClose(hWaveOut); hWaveOut=NULL;
			if (hmmio) mmioClose(hmmio, 0), hmmio=NULL;
			free_hdata();
		}
		fileclose();
		for (i=0; i<BUFNUM; ++i)
			GlobalUnlock(hWaveHdr[i]), GlobalFree(hWaveHdr[i]);
		//GlobalUnlock(NULL); GlobalFree(NULL);
		PostQuitMessage(0);
		//if (message==WM_QUERYENDSESSION) return TRUE;
		break;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}
void InitListView(HWND hList){
	HFONT hfont;
	LV_COLUMN lvcol;
	hfont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	SendMessage(hList, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;

	lvcol.cx=xx*0.9-cxChar*14*3-2; lvcol.pszText="O"; lvcol.iSubItem=0; ListView_InsertColumn(hList, 0, &lvcol);
	lvcol.fmt = LVCFMT_RIGHT;
	lvcol.cx=cxChar*14; lvcol.pszText="start"; lvcol.iSubItem=1; ListView_InsertColumn(hList, 1, &lvcol);
	lvcol.cx=cxChar*14; lvcol.pszText="end"; lvcol.iSubItem=2; ListView_InsertColumn(hList, 2, &lvcol);
	lvcol.cx=cxChar*14; lvcol.pszText="time"; lvcol.iSubItem=3; ListView_InsertColumn(hList, 3, &lvcol);
}
LRESULT CALLBACK ChildWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL InitApplication(HINSTANCE hInstance){
	WNDCLASS  wc;
	wc.style = 0;
	wc.lpfnWndProc = MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	//wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIcon = LoadIcon(hInstance, "ICON");
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	//wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszMenuName =  "Menu";
	wc.lpszClassName = "GenericWClass";
	if(RegisterClass(&wc)==FALSE) return FALSE;
	wc.style = 0;					/* NXX^C                   */
	wc.lpfnWndProc = ChildWndProc;  /* EChEvV[W           */
	wc.cbClsExtra = 0;              /* NXƂ̕⑫f[^Ȃ     */
	wc.cbWndExtra = 0;              /* EBhEƂ̕⑫f[^Ȃ */
	wc.hInstance = hInstance;       /* NXLAvP[V */
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_CROSS);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName =  NULL;        /* j[                     */
	wc.lpszClassName = "b2m_childWClass";/* CreateWindowŎg閼O       */
	/* EBhENXo^A܂͎sR[hԂ */
	if(RegisterClass(&wc)==FALSE) return FALSE;
	return TRUE;
}
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow){
	hinstApp=hInstance;
	/* Windows Version Zbg
		0x300: Windows 3.00
		0x30a: Windows 3.10
		0x30b: Windows 3.11
		0x35f: Windows 95 (16bit) (3.95)
		0x362: Windows 98 (16bit) (3.98)
		mF:Windows NT3.51(32b)(3.51)
		0x400: Windows 95 (32bit) (4.00)
		mF:Windows NT4(32bit) (4.00)
		0x40a: Windows 98 (32bit) (4.10)
		mF:Windows Me (32bit) (4.90)
		mF:Windows 2k (32bit) (5.00)
		0x501: Windows XP (32bit) (5.01)
		0x600: Windows Vista (32bit) 
		0x601: Windows Seven (32bit) 
	*/
	Version = LOWORD(GetVersion());
	Version = (WORD)((LOBYTE(Version)<<8) + HIBYTE(Version));
	DosVersion = HIWORD(GetVersion());
#ifdef WIN32
	if (DosVersion & 0x8000) NT=0; else NT=1;
	//hdc=GetDC(NULL);
	//sprintf(buf, "%x %d", DosVersion, NT);
	//TextOut(hdc, 0, 0, buf, strlen(buf));
	//ReleaseDC(NULL, hdc);
#else
	if (Version==0x35f) {
		if (DosVersion >=0x70a) Version+=3;
	}
#endif
	//sprintf(buf, "%hx", Version); MessageBox(NULL, buf, "WinVer", MB_OK);
	hwndApp = CreateWindow(
		"GenericWClass",APPNAME,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,NULL,hInstance,NULL
	);
	if (!hwndApp) return FALSE;
	InitCommonControls();
	hwndList = CreateWindow(WC_LISTVIEW, "",WS_CHILD | WS_VISIBLE | LVS_REPORT,
		0, 0, 0, 0,hwndApp,(HMENU)ID_LISTVIEW,hInstance,NULL);
	InitListView(hwndList);
	hwndChild = CreateWindow("b2m_childWClass","",WS_CHILD,
		0, 0, 0, 0, hwndApp,(HMENU)1,hInstance,NULL);
	if (!hwndChild) return FALSE;
#define BUTTON (WS_CHILD | WS_VISIBLE | WS_DISABLED | BS_PUSHBUTTON)
	hwndPlay = CreateWindow("BUTTON", Japan?"Đ":"Play", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_PLAY, hInstance, NULL);
	hwndStop = CreateWindow("BUTTON", Japan?"~":"Stop", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_STOP, hInstance, NULL);
	hwndOpen = CreateWindow("BUTTON", Japan?"J":"Open", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_OPEN, hInstance, NULL);
	hwndSave = CreateWindow("BUTTON", Japan?"ۑ":"Save", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_SAVE, hInstance, NULL);
	hwndDiv  = CreateWindow("BUTTON", Japan?"":"Div", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_DIV, hInstance, NULL);
	hwndJoin = CreateWindow("BUTTON", Japan?"":"Join", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_JOIN, hInstance, NULL);
	hwndDel  = CreateWindow("BUTTON", Japan?"":"Erace", BUTTON,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_DEL, hInstance, NULL);
	hwndLoop = CreateWindow("BUTTON", "Loop", WS_CHILD|WS_VISIBLE|BS_CHECKBOX,
		0, 0, 0, 0, hwndApp, (HMENU)IDM_LOOP, hInstance, NULL);
	CheckDlgButton(hwndApp, IDM_LOOP, loop);
	if (loop) CheckMenuItem(hmenu, IDM_LOOP, MF_CHECKED);
	else      CheckMenuItem(hmenu, IDM_LOOP, MF_UNCHECKED);
	if (dispmode==IDM_WAVE) CheckMenuItem(hmenu, IDM_WAVE, MF_CHECKED);
	else                    CheckMenuItem(hmenu, IDM_LEVEL, MF_CHECKED);
	EnableWindow(hwndOpen, TRUE);
	ShowWindow(hwndApp, nCmdShow);
	ShowWindow(hwndChild, SW_SHOW);
	SetFocus(hwndApp);
	UpdateWindow(hwndApp);
	return TRUE;
}
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){
	MSG msg;
	HACCEL hAccel=LoadAccelerators(hInstance, "Accel");
	if (!hPrevInstance)
		if (!InitApplication(hInstance))
			return FALSE;
	if (!InitInstance(hInstance, nCmdShow))
		return FALSE;
	while (GetMessage(&msg,NULL, 0, 0)) {
		if (!TranslateAccelerator(hwndApp, hAccel, &msg)) {
			//if (msg.message!=WM_KEYDOWN || !IsShortCutKey(&msg)) {
			//if (!IsDialogMessage(hwndApp, &msg)){
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			//}
		}
	}
	return (msg.wParam);
}
/*************************************************************************
g`plɕ\
*************************************************************************/
#define bai 1
#define MoveTo(h, x, y) MoveToEx(h, x, y, NULL)
#define NOSUP "No Support"
void FASTCALL dispwave(HDC hdc) {
	long rs, oldpos, readsize;
	int channel=wavetype&STEREO?2:1;
	int step=1;
	int BUNKAI;
	if (endpos==0 && status){//windows7΍
		MSG msg; char ststr[100], edstr[100]; int index;
		StopButton();
		CHECKMESSAGE2
		index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
		if (index) EnableMenuItem(hmenu,IDM_JOIN, MF_ENABLED),
				   EnableWindow(hwndJoin,TRUE);
		//ListView_GetItemText(hwndList, index, 0, buf, sizeof(buf));
		ListView_GetItemText(hwndList, index, 1, ststr, sizeof(ststr));
		ListView_GetItemText(hwndList, index, 2, edstr, sizeof(edstr));
		endpos=(long)(strtod(edstr,NULL)*BytesPerSec)/blockalign*blockalign;
		curpos=(long)(strtod(ststr,NULL)*BytesPerSec)/blockalign*blockalign;
		startpos=curpos;
		//dwDataSize=endpos-startpos;
		PlayButton();
	}
	BUNKAI=((endpos-startpos)/blockalign+HYOKO-1)/HYOKO;
	bunkai=((endpos-startpos)/blockalign+HYOKO-1)/HYOKO;
	BitBlt(hdc, 0, 0, HYOKO, HTATE, NULL, 0, 0, WHITENESS);
	if (endpos-startpos) step=HYOKO/((endpos-startpos)/blockalign);
	if (step==0) step=1;
	if (BUNKAI==0) BUNKAI=1;
	if (bunkai==0) bunkai=1;
	if (formattag != WAVE_FORMAT_PCM) {
		TextOut(hdc, 0, 0, NOSUP, strlen(NOSUP));
		return;
	}
	if (status) oldpos=mmioSeek(hmmio, 0, SEEK_CUR);
#if 0
	{
		char buf[100]; static int count; FILE *fp;
		sprintf(buf,"START %d %d %d ",count, startpos, endpos);
		SetWindowText(hwndApp, buf);
		fp=fopen("logfile.txt", "a");
		if (fp){
			fputs(buf, fp); putc('\n', fp);
			fclose(fp);
		}
		count++;
	}
#endif
	mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
	readsize=0;
	if(bits == 8){
		UCHAR *wk=(UCHAR *)malloc(BUNKAI*channel);
		if (wk==NULL) MsgBox("dispwave"), exit(1);
		if (dispmode==IDM_WAVE){
			int i, j, max, min;
			MoveTo(hdc, -1, 128*HTATE/(256/bai)-(bai==2?HTATE/2:0));
			for (i=0; i<HYOKO; i+=step){
				max=0; min=255;
				rs=mmioRead(hmmio, (HPSTR) wk, bunkai*channel);
				if (rs==0 || rs==-1) break;
				LineTo(hdc, i, wk[0]*HTATE/(256/bai)-(bai==2?HTATE/2:0));
				for (j=0; j<rs; ++j){
					if (wk[j]>max) max=wk[j];
					if (wk[j]<min) min=wk[j];
				}
				MoveTo(hdc, i, min*HTATE/(256/bai)-(bai==2?HTATE/2:0));
				LineTo(hdc, i, max*HTATE/(256/bai)-(bai==2?HTATE/2:0)+1);
				MoveTo(hdc, i, wk[(int)rs-1]*HTATE/(256/bai)-(bai==2?HTATE/2:0));
				if (rs!=bunkai*channel) break;
				readsize+=rs;
				if (readsize>=(endpos-startpos))break;
			}
		}else{
			int i, j; long max; double tmp;
			//int bunbo=65536L/HTATE/bai; int offset=(bai==2?HTATE/2:0);
			for (i=0; i<HYOKO; i+=step){
				max=0;
				rs=mmioRead(hmmio, (HPSTR) wk, bunkai*channel);
				if (rs==0 || rs==-1) break;
				for (j=0; j<rs/2; ++j){
					int d=((int)wk[j]-128); d=d*d;
					if (d>max) max=d;
				}
				if (max>0) tmp=log(max)/9.70406053; else tmp=-1;
				PatBlt(hdc, i, (1-tmp)*HTATE*2, step, tmp*HTATE, BLACKNESS);
				if (rs!=bunkai*channel) break;
				readsize+=rs;
				if (readsize>=(endpos-startpos))break;
			}
		}
		free(wk);
	}else if(bits == 16){
		signed short *wk=(signed short *)malloc(BUNKAI*channel*sizeof(short));
		if (wk==NULL) MsgBox("dispwave"), exit(1);
		if (dispmode==IDM_WAVE){
			int i, j; long max, min;
			int bunbo=65536L/HTATE/bai; int offset=(bai==2?HTATE/2:0);
			MoveTo(hdc, -1, HTATE/2);
			for (i=0; i<HYOKO; i+=step){
				max=-32768L; min=32767;
				rs=mmioRead(hmmio, (HPSTR) wk, bunkai*channel*2);
				if (rs==0 || rs==-1) break;
				LineTo(hdc, i, (wk[0]+32768U)          /bunbo-offset);
				for (j=0; j<rs/2; ++j){
					if (wk[j]>max) max=wk[j];
					if (wk[j]<min) min=wk[j];
				}
				MoveTo(hdc, i, (int)((min+32768U)      /bunbo-offset));
				LineTo(hdc, i, (int)((max+32768U)      /bunbo-offset+1));
				MoveTo(hdc, i, (wk[(int)rs/2-1]+32768U)/bunbo-offset);
				if (rs!=bunkai*channel*2) break;
				readsize+=rs;
				if (readsize>=(endpos-startpos))break;
			}
		}else{
			int i, j; long max; double tmp;
			//int bunbo=65536L/HTATE/bai; int offset=(bai==2?HTATE/2:0);
			for (i=0; i<HYOKO; i+=step){
				max=0;
				rs=mmioRead(hmmio, (HPSTR) wk, bunkai*channel*2);
				if (rs==0 || rs==-1) break;
				for (j=0; j<rs/2; ++j){
					long d=(long)wk[j]*wk[j];
					if (d>max) max=d;
				}
				if (max>0) tmp=log(max)/20.7944154; else tmp=-1;
				PatBlt(hdc, i, (1-tmp)*HTATE*2, step, tmp*HTATE, BLACKNESS);
				if (rs!=bunkai*channel*2) break;
				readsize+=rs;
				if (readsize>=(endpos-startpos))break;
			}
		}
		free(wk);
	}else{
		TextOut(hdc, 0, 0, NOSUP, strlen(NOSUP));
	}
	if (status) mmioSeek(hmmio, oldpos, SEEK_SET);
	else mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+startpos, SEEK_SET);
}
/****************************************************************************
֐: ChildWndProc(HWND, UINT, WPARAM, LPARAM) ړI:       bZ[W
: HWND hWnd;                   EBhEnh
	  UINT message;                bZ[W̃^Cv
	  WPARAM wParam;               ǉ
	  LPARAM lParam;               ǉ
****************************************************************************/
LRESULT CALLBACK ChildWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	HCURSOR hcur;
	//RECT rc;
	PAINTSTRUCT ps;
	HDC hdc;
	switch (message) {
	case WM_LBUTTONDOWN:
		if (hmmio) {
			char ststr[100], edstr[100]; double st, ed, pos;
			int index=ListView_GetNextItem(hwndList,-1,LVNI_SELECTED);
			if(index == -1) index=0;
			ListView_GetItemText(hwndList, index, 1, ststr, sizeof(ststr));
			ListView_GetItemText(hwndList, index, 2, edstr, sizeof(edstr));
			st=strtod(ststr, NULL);
			ed=strtod(edstr, NULL);
			pos=st+(ed-st)*(double)LOWORD(lParam)/HYOKO;
			pos=(long)(pos*BytesPerSec)/blockalign*blockalign;
			dwDataSize=endpos-pos;
			nokori=(dwDataSize/blockalign);
			if (buffnum==BUFNUM){
				mmioSeek(hmmio, mmckinfoSubchunk.dwDataOffset+pos, SEEK_SET);
				if (status) notDisp=BUFNUM-1,waveOutReset(hWaveOut);
			}else if (status){
				mmt.wType=TIME_BYTES;
				mmt.u.cb=pos;
				waveOutSetPosition(hWaveOut, lpWaveHdr[0], &mmt);
			}
			if (status==0) DispBar(-2,1,0), curpos=pos;
		}
		break;
	case WM_LBUTTONDBLCLK:case WM_RBUTTONDOWN:
		{
			BOOL statusbak=status;
			if (status && Version<0x500) StopButton();
		//sprintf(buf,"%d %d %f",LOWORD(lParam),HYOKO,(double)LOWORD(lParam)/HYOKO);
		//SetWindowText(hwndApp, buf);
			divsnd((double)LOWORD(lParam)/HYOKO);
			SetFocus(hwndList);
			if (statusbak && Version<0x500) PlayButton();
		}
		break;
	case WM_PAINT:
		//if (!bDIBLoaded) /* DIB[hĂȂꍇ͕`悵Ȃ */
			//return DefWindowProc(hWnd, message, wParam, lParam);
		hcur=LoadCursor(NULL, IDC_WAIT);
		hcur=SetCursor(hcur);
		hdc = BeginPaint(hWnd, &ps);
		//if (status==0 && kaiseki==0) {
			if (achFilePath[0]!=0 && hmmio==NULL) PrePlay();
			if (hmmio) dispwave(hdc);
		//}else need_redraw=1;
		EndPaint(hWnd, &ps);
		SetCursor(hcur);
		break;
	default:                    /* bZ[W͂̂܂ܓn     */
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
static WAVEHDR g_whdr;

void SetPositionUnprepareHeader(HWAVEOUT hwo){
    if(g_whdr.dwFlags & WHDR_PREPARED){
        waveOutUnprepareHeader(hwo,&g_whdr,sizeof(WAVEHDR));
    }
}
int waveOutSetPosition(HWAVEOUT hwo, LPWAVEHDR pwh, LPMMTIME pmmt){
    DWORD cb;
    switch(pmmt->wType){
        case TIME_BYTES:
            cb=pmmt->u.cb;
            break;
        case TIME_SAMPLES:
            cb=pmmt->u.sample * blockalign;
            break;
        case TIME_MS:
            cb=pmmt->u.ms * BytesPerSec / 1000;
            break;
        default:
            return -1;
    }
    if(cb % blockalign){
        if (cb % blockalign <= (DWORD)blockalign/2){
            cb-=(cb % blockalign);
        }else{
            cb+=(blockalign - (cb % blockalign));
        }
    }
    if(cb<0 || cb >= pwh->dwBufferLength) return -2;
	setpos=cb;

	stopflag = 1;
    waveOutReset(hwo);
    SetPositionUnprepareHeader(hwo);

    ZeroMemory(&g_whdr,sizeof(WAVEHDR));
    g_whdr.lpData=pwh->lpData + cb;
    g_whdr.dwBufferLength=pwh->dwBufferLength - cb;
    g_whdr.dwFlags=WHDR_BEGINLOOP | WHDR_ENDLOOP;
    g_whdr.dwLoops=1;

    waveOutPrepareHeader(hwo,&g_whdr,sizeof(WAVEHDR));
    waveOutWrite(hwo,&g_whdr,sizeof(WAVEHDR));
	stopflag = 0;
    return 0;
}

